# ! Callback Test Setup Version 584
import math,random

# Version 584
# I'm now precalculating the yRotate, xTran and zTran values, inspired by the precalculation of random numbers in the sample callback...
# - C:\Program Files\Poser Software\Poser 11\Runtime\Python\poserScripts\SampleCallbacks\randomHeadVerts.py a
# Now I can go backwards and forwards on the timeline and 

# INSTRUCTIONS FOR RUNNING TEST 584
# ---------------------------------
# 1) Load any figure and ensure its body is selected (figures that face along the +ve Z axis will look best)
# 2) [Optional:Increase the frame count from 30 if you want - 30 is enough to prove the principle, but 360 is more fun - I've arbitrarily set the limit to 360 frames of precalculated values]
# 3) Run this script - the precalculated values will be displayed in the debug window.
# 4) Use the animation controls

#--------------------------------------------------------------------
# Initialize the precalculated y rotations
#--------------------------------------------------------------------
def InitYRots():
	global ARRAY_SIZE
	global yRotArray
	global xTranArray
	global zTranArray
	ARRAY_SIZE=360
	yRotArray = range(ARRAY_SIZE)
	xTranArray = range(ARRAY_SIZE)
	zTranArray = range(ARRAY_SIZE)
	for i in range(ARRAY_SIZE):
		if i == 0:
			yRotArray[i] = 0
			xTranArray[i] = 0
			zTranArray[i] = 0
		else:
			yRotArray[i] = (yRotArray[i-1] + (30 * (random.random()-0.5))) % 360 
			xTranArray[i] = xTranArray[i-1] + (onestep*math.sin(math.radians(yRotArray[i])))
			zTranArray[i] = zTranArray[i-1] + (onestep*math.cos(math.radians(yRotArray[i])))
		print "Frame"+str(i)+": yR="+str(yRotArray[i])+", xT="+str(xTranArray[i])+", zT="+str(zTranArray[i])

#---------------------------------------------------------------------
# return the next precalculated y rotation
#---------------------------------------------------------------------
def GetYRot(frame):
	global yRotArray
	global ARRAY_SIZE
	if frame >ARRAY_SIZE:
		return yRotArray[ARRAY_SIZE]
	else:
		return yRotArray[frame]
#---------------------------------------------------------------------
# return the next precalculated x translation
#---------------------------------------------------------------------
def GetXTran(frame):
	global xTranArray
	global ARRAY_SIZE
	if frame >ARRAY_SIZE:
		return xTranArray[ARRAY_SIZE]
	else:
		return xTranArray[frame]
#---------------------------------------------------------------------
# return the next precalculated z translation
#---------------------------------------------------------------------
def GetZTran(frame):
	global zTranArray
	global ARRAY_SIZE
	if frame >ARRAY_SIZE:
		return zTranArray[ARRAY_SIZE]
	else:
		return zTranArray[frame]


# Callback for the "yRotate" parameter
def cheapskatesYRotateCallback(parm,value):
	global yRot
	global yRotFrame
	curframe = poser.Scene().Frame()
	if curframe != yRotFrame:
		yRot = GetYRot(curframe)
		yRotFrame = curframe
	return yRot

# Callback for the "xTran" parameter
def cheapskatesXTranCallback(parm,value):
	global xPos
	global xPosFrame
	curframe = poser.Scene().Frame()
	if curframe != xPosFrame:
		xPos = GetXTran(curframe)
		xPosFrame = curframe
	return xPos
	
# Callback for the "zTran" parameter
def cheapskatesZTranCallback(parm,value):
	global zPos
	global zPosFrame
	curframe = poser.Scene().Frame()
	if curframe != zPosFrame:
		zPos = GetZTran(curframe)
		zPosFrame = curframe
	return zPos

# Need to recalculate yRot,XTran, and zTran each frame based on calculated ('keyed', upper figure on dial) value from previous frame, NOT the dialed ('natural', lower figure on dial)
# This (i.e. using globals) seemed the easiest way to do it, at least for my first attempt
global yRot
global yRotFrame
global xPos
global xPosFrame
global zPos
global zPosFrame

# Arrays to hold precalulated values
global ARRAY_SIZE
global yRotArray
global xTranArray
global zTranArray

# These are just to avoid having to do 'body.Parameter("yRotate")' etc in the callbacks. There are others I could add too.
global parmXTran
global parmZTran
global onestep

# Initialize a few things
body=poser.Scene().CurrentFigure().ActorByInternalName("BODY")
parmYRot=body.Parameter("yRotate")
yRot=0
yRotFrame=0
xPos=0
xPosFrame=0
zPos=0
zPosFrame=0
parmXTran=body.Parameter("xTran")
parmZTran=body.Parameter("zTran")
onestep=0.1

# Initialize the precalculated array
InitYRots()
	
# Kick off the callbacks
print "Setting up the 'yRotate' callback..."
poser.Scene().CurrentActor().Parameter("yRotate").SetUpdateCallback(cheapskatesYRotateCallback)
print "Setting up the 'xTran' callback..."
poser.Scene().CurrentActor().Parameter("xTran").SetUpdateCallback(cheapskatesXTranCallback)
print "Setting up the 'zTran' callback..."
poser.Scene().CurrentActor().Parameter("zTran").SetUpdateCallback(cheapskatesZTranCallback)
print "...done."
